#include <stdio.h>
#include <stdlib.h>

#define _C_LABEL_STRING(f) f
#define __ifunc(name, resolver) \
	__asm(".globl	" _C_LABEL_STRING(#name) "\n" \
	      ".type	" _C_LABEL_STRING(#name) ", @gnu_indirect_function\n" \
	      ".set	" _C_LABEL_STRING(#name) ", " _C_LABEL_STRING(#resolver))

__ifunc(foo, resolve_foo);

extern void foo(void);
void (*bar)(void) = foo;

static void foo1(void) {
  printf("called foo1\n");
  printf("%p %p\n", bar, foo1);
}

static void foo2(void) {
  printf("called foo2\n");
}

void (*resolve_foo(void))(void)
{
    return foo1;
}
